#ifndef ARGYLL_TI1_H
#define ARGYLL_TI1_H

#include <string>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>

#include "argyll_support.h"
#include "gpdevicensupport.h"
#include "imagesource/devicencolorant.h"
#include "support/progress.h"

#include "ticgats.h"

// Class to handle the finer points of generating a test chart file suitable for DeviceN channel linearization.


// Support class to handle locating the TIFF files rendered by printtarg.
// Filenames must be freed when finished with.
class Argyll_TestChart_TIFFs
{
	public:
	Argyll_TestChart_TIFFs(const char *filenameroot);
	~Argyll_TestChart_TIFFs();
	char *GetFirstFilename();
	char *GetNextFilename();
	protected:
	char *fnroot;
	DIR *searchdirectory;
};


class Argyll_TestChartGenerator : public ArgyllSupport
{
	public:
	Argyll_TestChartGenerator();
	~Argyll_TestChartGenerator();
	// Targen support functions:
	std::string *BuildTargenColorants(GPColorantList *colorants);
	TIXFile *CreateRawChannelLinChart(const char *filenameroot,GPColorantList *colorants,int stepsperchannel,Progress *p=NULL);
	Argyll_TestChart_TIFFs *RenderTIFFs(const char *filenameroot,ArgyllPaperSize &size,ArgyllInstrument &inst,int res=200,int rnd=0,Progress *p=NULL);
	void DeleteTIFFs(const char *filenameroot);
};

#endif

