#include <iostream>
#include <cmath>

#include "imagesource/imagesource_modifiedgamma.h"
#include "linearization.h"
#include "linproject.h"
#include "ticgats.h"

using namespace std;

int main(int argc,char **argv)
{
	try
	{
		if(argc==2)
		{
			LinearizationCore core;
			LinProject proj(core);
			proj.SetFilename(argv[1]);
			proj.Load();
			char *fn=proj.GetTempRoot("RawLin",".ti3");
			char *fn2=proj.GetTempRoot("RawLin_GammaAdj",".ti3");

			TIXFile ti1(fn,"CTI3");
			double gamma = proj.gprinter.linearization.FindFloat("BaseGamma");

			int colorants=ti1.GetColorantCount();
			int sets=ti1.GetSets();
			for(int i=0;i<sets;++i)
			{
				double **data=ti1.GetData(i);
				for(int j=0;j<colorants;++j)
				{
					*data[j]=100.0*(1.0-ImageSource_ModifiedGamma::ModifiedGamma(1.0-(*data[j]/100.0),gamma));
					cerr << j << " : " << *data[j] << endl;
				}
			}
			ti1.Save(fn2);
			free(fn);
			free(fn2);
		}
		else
			throw "Usage: cgtest in.ti1 gamma out.ti1";
	}
	catch(const char *err)
	{
		cerr << "Error: " << err << endl;
	}
	return(0);
}

