#ifndef IMAGESOURCE_DROPSIZEMERGE_H
#define IMAGESOURCE_DROPSIZEMERGE_H

#include <iostream>

#include "imagesource/imagesource.h"

// Class to take n-channel input and merge channels in sets of 3

class ImageSource_DropSizeMerge : public ImageSource
{
	public:
	ImageSource_DropSizeMerge(ImageSource *source) : ImageSource(source), source(source)
	{
		samplesperpixel=(source->samplesperpixel+2)/3;
		type=IS_TYPE_DEVICEN;
		MakeRowBuffer();
		std::cerr << "ImageSource_DropSizeMerge: creating image with " << samplesperpixel << " samples per pixel" << std::endl;
	}
	virtual ~ImageSource_DropSizeMerge()
	{
		if(source)
			delete source;
	}
	virtual ISDataType *GetRow(int row)
	{
		if(row==currentrow)
			return(rowbuffer);
		for(int i=0;i<width*samplesperpixel;++i)
		{
			rowbuffer[i]=0;
		}
		ISDataType *src=source->GetRow(row);
		for(int x=0;x<width;++x)
		{
			for(int s=0;s<source->samplesperpixel;++s)
			{
				int s2=s/3;
				ISDataType t=src[x*source->samplesperpixel+s];
				if(t && !rowbuffer[x*samplesperpixel+s2])
					rowbuffer[x*samplesperpixel+s2]=t;
			}
		}
		currentrow=row;
		return(rowbuffer);
	}	
	protected:
	ImageSource *source;
};

#endif

