#include <iostream>

#include "labinterp.h"
#include "channelresponse.h"

using namespace std;

Interpolate_Lab::Interpolate_Lab() : Lcurve(), acurve(), bcurve()
{

}


Interpolate_Lab::~Interpolate_Lab()
{

}


void Interpolate_Lab::Populate(int count,ChannelResponseSample *samples,double smoothing)
{
	double *in=new double[count];
	double *L=new double[count];
	double *a=new double[count];
	double *b=new double[count];
	for(int i=0;i<count;++i)
	{
		LabValue lv(samples[i]);
		in[i]=samples[i].input;
		L[i]=lv.L;
		a[i]=lv.a;
		b[i]=lv.b;
	}
	Lcurve.Populate(count,in,L,smoothing);	// Minimal smoothing
	acurve.Populate(count,in,a,smoothing);
	bcurve.Populate(count,in,b,smoothing);
	delete[] b;
	delete[] a;
	delete[] L;
	delete[] in;
}


double Interpolate_Lab::ReverseInterpolate_L(double L)
{
	return(Lcurve.ReverseInterpolate(L));
}


double Interpolate_Lab::ReverseInterpolate_a(double a)
{
	return(acurve.ReverseInterpolate(a));
}


double Interpolate_Lab::ReverseInterpolate_b(double b)
{
	return(bcurve.ReverseInterpolate(b));
}


LabValue Interpolate_Lab::operator[](double in)
{
	LabValue result;
	result.L=Lcurve.Interpolate(in);
	result.a=acurve.Interpolate(in);
	result.b=bcurve.Interpolate(in);
	return(result);
}

