#ifndef LINEARIZATION_H
#define LINEARIZATION_H

// Class which handles the actual parameters and application of the linearization model.

#include "support/configdb.h"

#include "correctioncurve.h"

#define LINEARIZATION_MAX_CHANNELS 8

class ImageSource;
class Linearization : public ConfigDB
{
	public:
	Linearization(ConfigFile *file);
	~Linearization();
	ImageSource *Apply(ImageSource *source);
	double ForwardGamma(double in);	// Performs modified gamma correction - input range 0 - 1
	double ReverseGamma(double in);	// Performs reverse modified gamma correction - input range 0 - 1
	CorrectionCurve &operator[](int i);
									// Utility functions to compensate for limitations in the configdb
	void InkLimitToDB(int chan,float limit);
	float InkLimitFromDB(int chan);
	protected:
	static ConfigTemplate Template[];
	CorrectionCurve curves[LINEARIZATION_MAX_CHANNELS];
};

#endif

