#include <stdio.h>
#include <iostream>

#include <gutenprint/gutenprint.h>

#include "imagesource/imagesource_devicen_preview.h"

#include "ticgats.h"

#include "gpdevicensupport.h"

using namespace std;

int main(int argc,char **argv)
{
	stp_init();

	const char *driver="escp2-r285";
	if(argc>1)
		driver=argv[1];
	
	stp_vars_t *v=stp_vars_create();
	const stp_vars_t *defaults=stp_default_settings();
	stp_vars_copy(v,defaults);

	cerr << "Using driver: " << driver << endl;
	stp_set_driver(v,driver);
	const stp_printer_t *printer=stp_get_printer(v);
	if(printer)
	{
		cerr << "Setting defaults" << endl;
		stp_set_printer_defaults(v,printer);
		stp_set_string_parameter(v,"InputImageType","Raw");
		GPColorantList colorants(v);

		DeviceNColorant *col=colorants.FirstColorant();
		while(col)
		{
			const char *name=col->GetName();
			if(name)
				cerr << name << endl;
			else
				cerr << "<null colorant>" << endl;
			col=col->NextColorant();
		}

		int *channelmap=NULL;
		if(argc>2)
		{
			TIXFile ti1(argv[2]);
			channelmap=ti1.CreateRawChannelMap(colorants);
		}
		if(channelmap)
		{
			for(int i=0;i<colorants.GetColorantCount();++i)
			{
				cerr << "Channelmap["<< i << "], " << channelmap[i] << endl;
			}
		}

	}
	stp_vars_destroy(v);
	return(0);
}
