#ifndef __STEPSELECTOR_H__
#define __STEPSELECTOR_H__


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtkcombo.h>
#include <gtk/gtkcheckbutton.h>
#include <gtk/gtkvbox.h>
#include <gtk/gtkframe.h>
#include <gtk/gtklabel.h>
#include <gtk/gtktreeview.h>
#include <gtk/gtktreestore.h>
#include <gtk/gtkcellrendererpixbuf.h>

#include <gutenprint/gutenprint.h>

#include "imagesource/devicencolorant.h"
#include "gpdevicensupport.h"

#define STEPSELECTOR_TYPE			(stepselector_get_type())
#define STEPSELECTOR(obj)			(G_TYPE_CHECK_INSTANCE_CAST((obj), STEPSELECTOR_TYPE, StepSelector))
#define STEPSELECTOR_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), STEPSELECTOR_TYPE, StepSelectorClass))
#define IS_STEPSELECTOR(obj)			(G_TYPE_CHECK_INSTANCE_TYPE ((obj), STEPSELECTOR_TYPE))
#define IS_STEPSELECTOR_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), STEPSELECTOR_TYPE))

typedef struct _StepSelector StepSelector;
typedef struct _StepSelectorClass StepSelectorClass;


enum StepSelector_Step_Status {STEPSELECTOR_STATUS_NOTDONE,STEPSELECTOR_STATUS_DONE,STEP_SELECTOR_STATUS_SKIPPED};

class StepSelector_Step;
class StepSelector_StepList
{
	public:
	StepSelector_StepList();
	virtual ~StepSelector_StepList();
	virtual StepSelector_Step *FirstStep();
	virtual StepSelector_Step *operator[](int i);
	protected:
	StepSelector_Step *firststep;
	friend class StepSelector_Step;
};


class StepSelector_Step
{
	public:
	StepSelector_Step(StepSelector_StepList &header,const char *uiname);
	virtual ~StepSelector_Step();
	virtual enum StepSelector_Step_Status GetStatus();
	virtual const char *GetUIName();
	virtual int GetIndex();
	virtual StepSelector_Step *NextStep();
	virtual StepSelector_Step *PrevStep();
	protected:
	StepSelector_StepList &header;
	enum StepSelector_Step_Status status;
	char *uiname;
	int index;
	StepSelector_Step *nextstep,*prevstep;
};


struct _StepSelector
{
	GtkVBox box;
	GtkTreeStore *treestore;
	GtkWidget *treeview;
	StepSelector_StepList *list;
	GtkWidgetClass *parent_class;
};


struct _StepSelectorClass
{
	GtkVBoxClass parent_class;

	void (*changed)(StepSelector *es);
};

GType stepselector_get_type (void);

GtkWidget* stepselector_new (StepSelector_StepList *list=NULL);
int stepselector_get_index(StepSelector *sel);
StepSelector_Step *stepselector_get(StepSelector *sel);
void stepselector_set_index(StepSelector *sel,int idx);
void stepselector_refresh(StepSelector *c);
void stepselector_set_steps(StepSelector *c,StepSelector_StepList *list);


#endif /* __STEPSELECTOR_H__ */
