#ifndef STEPWIDGET_PRINTSETUP
#define STEPWIDGET_PRINTSETUP

#include <gtk/gtk.h>
#include <gutenprint/gutenprint.h>

#include "stpui_widgets/stpui_optionbook.h"

#include "projectgui.h"

class StepWidget_PrintSetup : public StepWidget
{
	public:
	StepWidget_PrintSetup(ProjectGUI *gui);
	~StepWidget_PrintSetup();
	virtual const char *GetDirections();
	virtual void SaveChanges();
	virtual void RevertChanges();
	protected:
	static void optionbook_changed(GtkWidget *wid,gpointer data);
	static void channelmode_changed(GtkWidget *wid,gpointer data);
	static void driver_changed(GtkWidget *wid,gpointer data);
	static void next(GtkWidget *wid,gpointer data);
	stp_vars_t *backupvars;
	char *olddriver;
	GtkWidget *printoutput;
	GtkWidget *optionbook;
	GtkWidget *channelmode;
	stpui_optionbook_custompage custompage;
};

//	Creator subclass for GUI
DEFINE_GUI_STEP(PrintSetup);

#endif

